/* Blurhash.c generated by valac 0.56.17, the Vala compiler
 * generated from Blurhash.vala, do not modify */

/* Blurhash decoding in pure Vala inspired by*/
/* https://github.com/woltapp/blurhash and https://github.com/mad-gooze/fast-blurhash/*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUBA_TYPE_BLURHASH (tuba_blurhash_get_type ())
#define TUBA_BLURHASH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_TYPE_BLURHASH, TubaBlurhash))
#define TUBA_BLURHASH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_TYPE_BLURHASH, TubaBlurhashClass))
#define TUBA_IS_BLURHASH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_TYPE_BLURHASH))
#define TUBA_IS_BLURHASH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_TYPE_BLURHASH))
#define TUBA_BLURHASH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_TYPE_BLURHASH, TubaBlurhashClass))

typedef struct _TubaBlurhash TubaBlurhash;
typedef struct _TubaBlurhashClass TubaBlurhashClass;
typedef struct _TubaBlurhashPrivate TubaBlurhashPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUBA_BLURHASH_TYPE_AVERAGE_COLOR (tuba_blurhash_average_color_get_type ())
typedef struct _TubaBlurhashAverageColor TubaBlurhashAverageColor;

#define TUBA_BLURHASH_TYPE_COLOR_SRGB (tuba_blurhash_color_srgb_get_type ())
typedef struct _TubaBlurhashColorSRGB TubaBlurhashColorSRGB;

#define TUBA_BLURHASH_TYPE_BASE83 (tuba_blurhash_base83_get_type ())
#define TUBA_BLURHASH_BASE83(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_BLURHASH_TYPE_BASE83, TubaBlurhashBase83))
#define TUBA_BLURHASH_BASE83_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_BLURHASH_TYPE_BASE83, TubaBlurhashBase83Class))
#define TUBA_BLURHASH_IS_BASE83(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_BLURHASH_TYPE_BASE83))
#define TUBA_BLURHASH_IS_BASE83_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_BLURHASH_TYPE_BASE83))
#define TUBA_BLURHASH_BASE83_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_BLURHASH_TYPE_BASE83, TubaBlurhashBase83Class))

typedef struct _TubaBlurhashBase83 TubaBlurhashBase83;
typedef struct _TubaBlurhashBase83Class TubaBlurhashBase83Class;
typedef struct _TubaBlurhashBase83Private TubaBlurhashBase83Private;
typedef struct _TubaBlurhashParamSpecBase83 TubaBlurhashParamSpecBase83;
typedef struct _TubaParamSpecBlurhash TubaParamSpecBlurhash;

struct _TubaBlurhash {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TubaBlurhashPrivate * priv;
};

struct _TubaBlurhashClass {
	GTypeClass parent_class;
	void (*finalize) (TubaBlurhash *self);
};

struct _TubaBlurhashAverageColor {
	gint r;
	gint g;
	gint b;
};

struct _TubaBlurhashColorSRGB {
	gfloat r;
	gfloat g;
	gfloat b;
};

struct _TubaBlurhashBase83 {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TubaBlurhashBase83Private * priv;
};

struct _TubaBlurhashBase83Class {
	GTypeClass parent_class;
	void (*finalize) (TubaBlurhashBase83 *self);
};

struct _TubaBlurhashParamSpecBase83 {
	GParamSpec parent_instance;
};

struct _TubaParamSpecBlurhash {
	GParamSpec parent_instance;
};

static gpointer tuba_blurhash_parent_class = NULL;
static gpointer tuba_blurhash_base83_parent_class = NULL;

VALA_EXTERN gpointer tuba_blurhash_ref (gpointer instance);
VALA_EXTERN void tuba_blurhash_unref (gpointer instance);
VALA_EXTERN GParamSpec* tuba_param_spec_blurhash (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void tuba_value_set_blurhash (GValue* value,
                              gpointer v_object);
VALA_EXTERN void tuba_value_take_blurhash (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer tuba_value_get_blurhash (const GValue* value);
VALA_EXTERN GType tuba_blurhash_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaBlurhash, tuba_blurhash_unref)
static gint tuba_blurhash_decode_partial (const gchar* str,
                                   gint start,
                                   gint end);
VALA_EXTERN gint tuba_blurhash_base83_decode (const gchar* value);
static gint tuba_blurhash_linear_to_srgb (gfloat value);
static gfloat tuba_blurhash_srgb_to_linear (gint value);
static gfloat tuba_blurhash_sign_pow (gfloat value,
                               gfloat exp);
VALA_EXTERN gboolean tuba_blurhash_is_valid_blurhash (const gchar* blurhash,
                                          gint* size_flag,
                                          gint* num_x,
                                          gint* num_y,
                                          gint* size);
static GType tuba_blurhash_average_color_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static TubaBlurhashAverageColor* tuba_blurhash_average_color_dup (const TubaBlurhashAverageColor* self);
static void tuba_blurhash_average_color_free (TubaBlurhashAverageColor* self);
static void tuba_blurhash_get_blurhash_average_color (const gchar* blurhash,
                                               TubaBlurhashAverageColor* result);
static GType tuba_blurhash_color_srgb_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static TubaBlurhashColorSRGB* tuba_blurhash_color_srgb_dup (const TubaBlurhashColorSRGB* self);
static void tuba_blurhash_color_srgb_free (TubaBlurhashColorSRGB* self);
static void tuba_blurhash_decode_ac (gint value,
                              gfloat maximum_value,
                              TubaBlurhashColorSRGB* result);
VALA_EXTERN guint8* tuba_blurhash_decode_to_data (const gchar* blurhash,
                                      gint width,
                                      gint height,
                                      gint punch,
                                      gboolean has_alpha,
                                      gint* result_length1);
VALA_EXTERN GdkPixbuf* tuba_blurhash_blurhash_to_pixbuf (const gchar* blurhash,
                                             gint width,
                                             gint height);
static guint8* _vala_array_dup16 (guint8* self,
                           gssize length);
static void _g_free_gdk_pixbuf_destroy_notify (guint8* pixels,
                                        gpointer self);
VALA_EXTERN TubaBlurhash* tuba_blurhash_new (void);
VALA_EXTERN TubaBlurhash* tuba_blurhash_construct (GType object_type);
VALA_EXTERN gpointer tuba_blurhash_base83_ref (gpointer instance);
VALA_EXTERN void tuba_blurhash_base83_unref (gpointer instance);
VALA_EXTERN GParamSpec* tuba_blurhash_param_spec_base83 (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
VALA_EXTERN void tuba_blurhash_value_set_base83 (GValue* value,
                                     gpointer v_object);
VALA_EXTERN void tuba_blurhash_value_take_base83 (GValue* value,
                                      gpointer v_object);
VALA_EXTERN gpointer tuba_blurhash_value_get_base83 (const GValue* value);
VALA_EXTERN GType tuba_blurhash_base83_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaBlurhashBase83, tuba_blurhash_base83_unref)
VALA_EXTERN TubaBlurhashBase83* tuba_blurhash_base83_new (void);
VALA_EXTERN TubaBlurhashBase83* tuba_blurhash_base83_construct (GType object_type);
static void tuba_blurhash_base83_finalize (TubaBlurhashBase83 * obj);
static GType tuba_blurhash_base83_get_type_once (void);
static void tuba_blurhash_finalize (TubaBlurhash * obj);
static GType tuba_blurhash_get_type_once (void);

static const gchar TUBA_BLURHASH_BASE83_CHARACTERS[83] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '#', '$', '%', '*', '+', ',', '-', '.', ':', ';', '=', '?', '@', '[', ']', '^', '_', '{', '|', '}', '~'};

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 211 "Blurhash.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 217 "Blurhash.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 223 "Blurhash.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 227 "Blurhash.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 235 "Blurhash.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 239 "Blurhash.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 251 "Blurhash.c"
}

static gint
tuba_blurhash_decode_partial (const gchar* str,
                              gint start,
                              gint end)
{
	gint str_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 58 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 59 "../src/Utils/Blurhash.vala"
	if (start > end) {
#line 59 "../src/Utils/Blurhash.vala"
		result = 0;
#line 59 "../src/Utils/Blurhash.vala"
		return result;
#line 274 "Blurhash.c"
	}
#line 61 "../src/Utils/Blurhash.vala"
	_tmp0_ = strlen (str);
#line 61 "../src/Utils/Blurhash.vala"
	_tmp1_ = _tmp0_;
#line 61 "../src/Utils/Blurhash.vala"
	str_length = _tmp1_;
#line 62 "../src/Utils/Blurhash.vala"
	if (end >= str_length) {
#line 62 "../src/Utils/Blurhash.vala"
		end = str_length;
#line 286 "Blurhash.c"
	}
#line 64 "../src/Utils/Blurhash.vala"
	_tmp2_ = string_slice (str, (glong) start, (glong) end);
#line 64 "../src/Utils/Blurhash.vala"
	_tmp3_ = _tmp2_;
#line 64 "../src/Utils/Blurhash.vala"
	_tmp4_ = tuba_blurhash_base83_decode (_tmp3_);
#line 64 "../src/Utils/Blurhash.vala"
	_g_free0 (_tmp3_);
#line 64 "../src/Utils/Blurhash.vala"
	result = _tmp4_;
#line 64 "../src/Utils/Blurhash.vala"
	return result;
#line 300 "Blurhash.c"
}

static gint
tuba_blurhash_linear_to_srgb (gfloat value)
{
	gfloat v = 0.0F;
	gint result;
#line 68 "../src/Utils/Blurhash.vala"
	v = CLAMP (value, 0.f, 1.f);
#line 69 "../src/Utils/Blurhash.vala"
	if (((gdouble) v) <= 0.0031308) {
#line 69 "../src/Utils/Blurhash.vala"
		result = (gint) (((v * 12.92f) * 255) + 0.5);
#line 69 "../src/Utils/Blurhash.vala"
		return result;
#line 316 "Blurhash.c"
	}
#line 71 "../src/Utils/Blurhash.vala"
	result = (gint) ((((1.055 * powf (v, 1 / 2.4f)) - 0.055) * 255) + 0.5);
#line 71 "../src/Utils/Blurhash.vala"
	return result;
#line 322 "Blurhash.c"
}

static gfloat
tuba_blurhash_srgb_to_linear (gint value)
{
	gfloat v = 0.0F;
	gfloat result;
#line 75 "../src/Utils/Blurhash.vala"
	v = value / 255.f;
#line 76 "../src/Utils/Blurhash.vala"
	if (((gdouble) v) <= 0.04045) {
#line 76 "../src/Utils/Blurhash.vala"
		result = v / 12.92f;
#line 76 "../src/Utils/Blurhash.vala"
		return result;
#line 338 "Blurhash.c"
	}
#line 78 "../src/Utils/Blurhash.vala"
	result = powf ((v + 0.055f) / 1.055f, 2.4f);
#line 78 "../src/Utils/Blurhash.vala"
	return result;
#line 344 "Blurhash.c"
}

static gfloat
tuba_blurhash_sign_pow (gfloat value,
                        gfloat exp)
{
	gfloat result;
#line 82 "../src/Utils/Blurhash.vala"
	result = copysignf (powf (fabsf (value), exp), value);
#line 82 "../src/Utils/Blurhash.vala"
	return result;
#line 356 "Blurhash.c"
}

gboolean
tuba_blurhash_is_valid_blurhash (const gchar* blurhash,
                                 gint* size_flag,
                                 gint* num_x,
                                 gint* num_y,
                                 gint* size)
{
	gint _vala_size_flag = 0;
	gint _vala_num_x = 0;
	gint _vala_num_y = 0;
	gint _vala_size = 0;
	gint hash_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 85 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (blurhash != NULL, FALSE);
#line 86 "../src/Utils/Blurhash.vala"
	_vala_size_flag = 0;
#line 87 "../src/Utils/Blurhash.vala"
	_vala_num_y = 0;
#line 88 "../src/Utils/Blurhash.vala"
	_vala_num_x = 0;
#line 89 "../src/Utils/Blurhash.vala"
	_vala_size = 0;
#line 91 "../src/Utils/Blurhash.vala"
	_tmp0_ = strlen (blurhash);
#line 91 "../src/Utils/Blurhash.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Utils/Blurhash.vala"
	hash_length = _tmp1_;
#line 92 "../src/Utils/Blurhash.vala"
	if (hash_length < 6) {
#line 92 "../src/Utils/Blurhash.vala"
		result = FALSE;
#line 92 "../src/Utils/Blurhash.vala"
		if (size_flag) {
#line 92 "../src/Utils/Blurhash.vala"
			*size_flag = _vala_size_flag;
#line 398 "Blurhash.c"
		}
#line 92 "../src/Utils/Blurhash.vala"
		if (num_x) {
#line 92 "../src/Utils/Blurhash.vala"
			*num_x = _vala_num_x;
#line 404 "Blurhash.c"
		}
#line 92 "../src/Utils/Blurhash.vala"
		if (num_y) {
#line 92 "../src/Utils/Blurhash.vala"
			*num_y = _vala_num_y;
#line 410 "Blurhash.c"
		}
#line 92 "../src/Utils/Blurhash.vala"
		if (size) {
#line 92 "../src/Utils/Blurhash.vala"
			*size = _vala_size;
#line 416 "Blurhash.c"
		}
#line 92 "../src/Utils/Blurhash.vala"
		return result;
#line 420 "Blurhash.c"
	}
#line 94 "../src/Utils/Blurhash.vala"
	_vala_size_flag = tuba_blurhash_decode_partial (blurhash, 0, 1);
#line 95 "../src/Utils/Blurhash.vala"
	_vala_num_y = ((gint) floorf ((gfloat) (_vala_size_flag / 9))) + 1;
#line 96 "../src/Utils/Blurhash.vala"
	_vala_num_x = (_vala_size_flag % 9) + 1;
#line 97 "../src/Utils/Blurhash.vala"
	_vala_size = _vala_num_x * _vala_num_y;
#line 99 "../src/Utils/Blurhash.vala"
	if (hash_length != (4 + (2 * _vala_size))) {
#line 99 "../src/Utils/Blurhash.vala"
		result = FALSE;
#line 99 "../src/Utils/Blurhash.vala"
		if (size_flag) {
#line 99 "../src/Utils/Blurhash.vala"
			*size_flag = _vala_size_flag;
#line 438 "Blurhash.c"
		}
#line 99 "../src/Utils/Blurhash.vala"
		if (num_x) {
#line 99 "../src/Utils/Blurhash.vala"
			*num_x = _vala_num_x;
#line 444 "Blurhash.c"
		}
#line 99 "../src/Utils/Blurhash.vala"
		if (num_y) {
#line 99 "../src/Utils/Blurhash.vala"
			*num_y = _vala_num_y;
#line 450 "Blurhash.c"
		}
#line 99 "../src/Utils/Blurhash.vala"
		if (size) {
#line 99 "../src/Utils/Blurhash.vala"
			*size = _vala_size;
#line 456 "Blurhash.c"
		}
#line 99 "../src/Utils/Blurhash.vala"
		return result;
#line 460 "Blurhash.c"
	}
#line 100 "../src/Utils/Blurhash.vala"
	result = TRUE;
#line 100 "../src/Utils/Blurhash.vala"
	if (size_flag) {
#line 100 "../src/Utils/Blurhash.vala"
		*size_flag = _vala_size_flag;
#line 468 "Blurhash.c"
	}
#line 100 "../src/Utils/Blurhash.vala"
	if (num_x) {
#line 100 "../src/Utils/Blurhash.vala"
		*num_x = _vala_num_x;
#line 474 "Blurhash.c"
	}
#line 100 "../src/Utils/Blurhash.vala"
	if (num_y) {
#line 100 "../src/Utils/Blurhash.vala"
		*num_y = _vala_num_y;
#line 480 "Blurhash.c"
	}
#line 100 "../src/Utils/Blurhash.vala"
	if (size) {
#line 100 "../src/Utils/Blurhash.vala"
		*size = _vala_size;
#line 486 "Blurhash.c"
	}
#line 100 "../src/Utils/Blurhash.vala"
	return result;
#line 490 "Blurhash.c"
}

static void
tuba_blurhash_get_blurhash_average_color (const gchar* blurhash,
                                          TubaBlurhashAverageColor* result)
{
	gint val = 0;
	TubaBlurhashAverageColor _tmp0_ = {0};
#line 103 "../src/Utils/Blurhash.vala"
	g_return_if_fail (blurhash != NULL);
#line 104 "../src/Utils/Blurhash.vala"
	val = tuba_blurhash_decode_partial (blurhash, 2, 6);
#line 105 "../src/Utils/Blurhash.vala"
	_tmp0_.r = val >> 16;
#line 105 "../src/Utils/Blurhash.vala"
	_tmp0_.g = (val >> 8) & 255;
#line 105 "../src/Utils/Blurhash.vala"
	_tmp0_.b = val & 255;
#line 105 "../src/Utils/Blurhash.vala"
	*result = _tmp0_;
#line 105 "../src/Utils/Blurhash.vala"
	return;
#line 513 "Blurhash.c"
}

static void
tuba_blurhash_decode_ac (gint value,
                         gfloat maximum_value,
                         TubaBlurhashColorSRGB* result)
{
	gint quant_r = 0;
	gint quant_g = 0;
	gint quant_b = 0;
	TubaBlurhashColorSRGB _tmp0_ = {0};
#line 109 "../src/Utils/Blurhash.vala"
	quant_r = (gint) floorf ((gfloat) (value / (19 * 19)));
#line 110 "../src/Utils/Blurhash.vala"
	quant_g = ((gint) floorf ((gfloat) (value / 19))) % 19;
#line 111 "../src/Utils/Blurhash.vala"
	quant_b = ((gint) value) % 19;
#line 113 "../src/Utils/Blurhash.vala"
	memset (&_tmp0_, 0, sizeof (TubaBlurhashColorSRGB));
#line 113 "../src/Utils/Blurhash.vala"
	_tmp0_.r = tuba_blurhash_sign_pow ((((gfloat) quant_r) - 9) / 9, 2.0f) * maximum_value;
#line 113 "../src/Utils/Blurhash.vala"
	_tmp0_.g = tuba_blurhash_sign_pow ((((gfloat) quant_g) - 9) / 9, 2.0f) * maximum_value;
#line 113 "../src/Utils/Blurhash.vala"
	_tmp0_.b = tuba_blurhash_sign_pow ((((gfloat) quant_b) - 9) / 9, 2.0f) * maximum_value;
#line 113 "../src/Utils/Blurhash.vala"
	*result = _tmp0_;
#line 113 "../src/Utils/Blurhash.vala"
	return;
#line 543 "Blurhash.c"
}

guint8*
tuba_blurhash_decode_to_data (const gchar* blurhash,
                              gint width,
                              gint height,
                              gint punch,
                              gboolean has_alpha,
                              gint* result_length1)
{
	gint _tmp0_ = 0;
	gint bytes_per_row = 0;
	guint8* res = NULL;
	guint8* _tmp1_;
	gint res_length1;
	gint _res_size_;
	gint size_flag = 0;
	gint num_y = 0;
	gint num_x = 0;
	gint size = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gfloat maximum_value = 0.0F;
	gfloat* colors = NULL;
	gfloat* _tmp8_;
	gint colors_length1;
	gint _colors_size_;
	TubaBlurhashAverageColor average_color = {0};
	TubaBlurhashAverageColor _tmp9_ = {0};
	gfloat* _tmp10_;
	gint _tmp10__length1;
	TubaBlurhashAverageColor _tmp11_;
	gfloat* _tmp12_;
	gint _tmp12__length1;
	TubaBlurhashAverageColor _tmp13_;
	gfloat* _tmp14_;
	gint _tmp14__length1;
	TubaBlurhashAverageColor _tmp15_;
	guint8* _tmp43_;
	gint _tmp43__length1;
	guint8* result;
#line 120 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (blurhash != NULL, NULL);
#line 121 "../src/Utils/Blurhash.vala"
	if (has_alpha) {
#line 121 "../src/Utils/Blurhash.vala"
		_tmp0_ = 4;
#line 594 "Blurhash.c"
	} else {
#line 121 "../src/Utils/Blurhash.vala"
		_tmp0_ = 3;
#line 598 "Blurhash.c"
	}
#line 121 "../src/Utils/Blurhash.vala"
	bytes_per_row = width * _tmp0_;
#line 122 "../src/Utils/Blurhash.vala"
	_tmp1_ = g_new0 (guint8, bytes_per_row * height);
#line 122 "../src/Utils/Blurhash.vala"
	res = _tmp1_;
#line 122 "../src/Utils/Blurhash.vala"
	res_length1 = bytes_per_row * height;
#line 122 "../src/Utils/Blurhash.vala"
	_res_size_ = res_length1;
#line 129 "../src/Utils/Blurhash.vala"
	_tmp6_ = tuba_blurhash_is_valid_blurhash (blurhash, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 129 "../src/Utils/Blurhash.vala"
	size_flag = _tmp2_;
#line 129 "../src/Utils/Blurhash.vala"
	num_x = _tmp3_;
#line 129 "../src/Utils/Blurhash.vala"
	num_y = _tmp4_;
#line 129 "../src/Utils/Blurhash.vala"
	size = _tmp5_;
#line 129 "../src/Utils/Blurhash.vala"
	if (!_tmp6_) {
#line 622 "Blurhash.c"
		guint8* _tmp7_;
		gint _tmp7__length1;
#line 129 "../src/Utils/Blurhash.vala"
		_tmp7_ = NULL;
#line 129 "../src/Utils/Blurhash.vala"
		_tmp7__length1 = 0;
#line 129 "../src/Utils/Blurhash.vala"
		if (result_length1) {
#line 129 "../src/Utils/Blurhash.vala"
			*result_length1 = _tmp7__length1;
#line 633 "Blurhash.c"
		}
#line 129 "../src/Utils/Blurhash.vala"
		result = _tmp7_;
#line 129 "../src/Utils/Blurhash.vala"
		res = (g_free (res), NULL);
#line 129 "../src/Utils/Blurhash.vala"
		return result;
#line 641 "Blurhash.c"
	}
#line 130 "../src/Utils/Blurhash.vala"
	if (punch < 1) {
#line 130 "../src/Utils/Blurhash.vala"
		punch = 1;
#line 647 "Blurhash.c"
	}
#line 132 "../src/Utils/Blurhash.vala"
	maximum_value = ((gfloat) (tuba_blurhash_decode_partial (blurhash, 1, 2) + 1)) / 166;
#line 133 "../src/Utils/Blurhash.vala"
	_tmp8_ = g_new0 (gfloat, size * 3);
#line 133 "../src/Utils/Blurhash.vala"
	colors = _tmp8_;
#line 133 "../src/Utils/Blurhash.vala"
	colors_length1 = size * 3;
#line 133 "../src/Utils/Blurhash.vala"
	_colors_size_ = colors_length1;
#line 135 "../src/Utils/Blurhash.vala"
	tuba_blurhash_get_blurhash_average_color (blurhash, &_tmp9_);
#line 135 "../src/Utils/Blurhash.vala"
	average_color = _tmp9_;
#line 136 "../src/Utils/Blurhash.vala"
	_tmp10_ = colors;
#line 136 "../src/Utils/Blurhash.vala"
	_tmp10__length1 = colors_length1;
#line 136 "../src/Utils/Blurhash.vala"
	_tmp11_ = average_color;
#line 136 "../src/Utils/Blurhash.vala"
	_tmp10_[0] = tuba_blurhash_srgb_to_linear (_tmp11_.r);
#line 137 "../src/Utils/Blurhash.vala"
	_tmp12_ = colors;
#line 137 "../src/Utils/Blurhash.vala"
	_tmp12__length1 = colors_length1;
#line 137 "../src/Utils/Blurhash.vala"
	_tmp13_ = average_color;
#line 137 "../src/Utils/Blurhash.vala"
	_tmp12_[1] = tuba_blurhash_srgb_to_linear (_tmp13_.g);
#line 138 "../src/Utils/Blurhash.vala"
	_tmp14_ = colors;
#line 138 "../src/Utils/Blurhash.vala"
	_tmp14__length1 = colors_length1;
#line 138 "../src/Utils/Blurhash.vala"
	_tmp15_ = average_color;
#line 138 "../src/Utils/Blurhash.vala"
	_tmp14_[2] = tuba_blurhash_srgb_to_linear (_tmp15_.b);
#line 687 "Blurhash.c"
	{
		gint i = 0;
#line 140 "../src/Utils/Blurhash.vala"
		i = 1;
#line 692 "Blurhash.c"
		{
			gboolean _tmp16_ = FALSE;
#line 140 "../src/Utils/Blurhash.vala"
			_tmp16_ = TRUE;
#line 140 "../src/Utils/Blurhash.vala"
			while (TRUE) {
#line 699 "Blurhash.c"
				gint value = 0;
				TubaBlurhashColorSRGB color = {0};
				TubaBlurhashColorSRGB _tmp18_ = {0};
				gfloat* _tmp19_;
				gint _tmp19__length1;
				TubaBlurhashColorSRGB _tmp20_;
				gfloat* _tmp21_;
				gint _tmp21__length1;
				TubaBlurhashColorSRGB _tmp22_;
				gfloat* _tmp23_;
				gint _tmp23__length1;
				TubaBlurhashColorSRGB _tmp24_;
#line 140 "../src/Utils/Blurhash.vala"
				if (!_tmp16_) {
#line 714 "Blurhash.c"
					gint _tmp17_;
#line 140 "../src/Utils/Blurhash.vala"
					_tmp17_ = i;
#line 140 "../src/Utils/Blurhash.vala"
					i = _tmp17_ + 1;
#line 720 "Blurhash.c"
				}
#line 140 "../src/Utils/Blurhash.vala"
				_tmp16_ = FALSE;
#line 140 "../src/Utils/Blurhash.vala"
				if (!(i < size)) {
#line 140 "../src/Utils/Blurhash.vala"
					break;
#line 728 "Blurhash.c"
				}
#line 141 "../src/Utils/Blurhash.vala"
				value = tuba_blurhash_decode_partial (blurhash, 4 + (i * 2), 6 + (i * 2));
#line 143 "../src/Utils/Blurhash.vala"
				tuba_blurhash_decode_ac (value, maximum_value, &_tmp18_);
#line 143 "../src/Utils/Blurhash.vala"
				color = _tmp18_;
#line 144 "../src/Utils/Blurhash.vala"
				_tmp19_ = colors;
#line 144 "../src/Utils/Blurhash.vala"
				_tmp19__length1 = colors_length1;
#line 144 "../src/Utils/Blurhash.vala"
				_tmp20_ = color;
#line 144 "../src/Utils/Blurhash.vala"
				_tmp19_[i * 3] = _tmp20_.r;
#line 145 "../src/Utils/Blurhash.vala"
				_tmp21_ = colors;
#line 145 "../src/Utils/Blurhash.vala"
				_tmp21__length1 = colors_length1;
#line 145 "../src/Utils/Blurhash.vala"
				_tmp22_ = color;
#line 145 "../src/Utils/Blurhash.vala"
				_tmp21_[(i * 3) + 1] = _tmp22_.g;
#line 146 "../src/Utils/Blurhash.vala"
				_tmp23_ = colors;
#line 146 "../src/Utils/Blurhash.vala"
				_tmp23__length1 = colors_length1;
#line 146 "../src/Utils/Blurhash.vala"
				_tmp24_ = color;
#line 146 "../src/Utils/Blurhash.vala"
				_tmp23_[(i * 3) + 2] = _tmp24_.b;
#line 760 "Blurhash.c"
			}
		}
	}
	{
		gint y = 0;
#line 149 "../src/Utils/Blurhash.vala"
		y = 0;
#line 768 "Blurhash.c"
		{
			gboolean _tmp25_ = FALSE;
#line 149 "../src/Utils/Blurhash.vala"
			_tmp25_ = TRUE;
#line 149 "../src/Utils/Blurhash.vala"
			while (TRUE) {
#line 775 "Blurhash.c"
				gfloat yh = 0.0F;
#line 149 "../src/Utils/Blurhash.vala"
				if (!_tmp25_) {
#line 779 "Blurhash.c"
					gint _tmp26_;
#line 149 "../src/Utils/Blurhash.vala"
					_tmp26_ = y;
#line 149 "../src/Utils/Blurhash.vala"
					y = _tmp26_ + 1;
#line 785 "Blurhash.c"
				}
#line 149 "../src/Utils/Blurhash.vala"
				_tmp25_ = FALSE;
#line 149 "../src/Utils/Blurhash.vala"
				if (!(y < height)) {
#line 149 "../src/Utils/Blurhash.vala"
					break;
#line 793 "Blurhash.c"
				}
#line 150 "../src/Utils/Blurhash.vala"
				yh = ((gfloat) (G_PI * y)) / height;
#line 797 "Blurhash.c"
				{
					gint x = 0;
#line 151 "../src/Utils/Blurhash.vala"
					x = 0;
#line 802 "Blurhash.c"
					{
						gboolean _tmp27_ = FALSE;
#line 151 "../src/Utils/Blurhash.vala"
						_tmp27_ = TRUE;
#line 151 "../src/Utils/Blurhash.vala"
						while (TRUE) {
#line 809 "Blurhash.c"
							gfloat r = 0.0F;
							gfloat g = 0.0F;
							gfloat b = 0.0F;
							gfloat xw = 0.0F;
							gint pixel_index = 0;
							guint8* _tmp39_;
							gint _tmp39__length1;
							guint8* _tmp40_;
							gint _tmp40__length1;
							guint8* _tmp41_;
							gint _tmp41__length1;
#line 151 "../src/Utils/Blurhash.vala"
							if (!_tmp27_) {
#line 823 "Blurhash.c"
								gint _tmp28_;
#line 151 "../src/Utils/Blurhash.vala"
								_tmp28_ = x;
#line 151 "../src/Utils/Blurhash.vala"
								x = _tmp28_ + 1;
#line 829 "Blurhash.c"
							}
#line 151 "../src/Utils/Blurhash.vala"
							_tmp27_ = FALSE;
#line 151 "../src/Utils/Blurhash.vala"
							if (!(x < width)) {
#line 151 "../src/Utils/Blurhash.vala"
								break;
#line 837 "Blurhash.c"
							}
#line 152 "../src/Utils/Blurhash.vala"
							r = (gfloat) 0;
#line 153 "../src/Utils/Blurhash.vala"
							g = (gfloat) 0;
#line 154 "../src/Utils/Blurhash.vala"
							b = (gfloat) 0;
#line 155 "../src/Utils/Blurhash.vala"
							xw = ((gfloat) (G_PI * x)) / width;
#line 847 "Blurhash.c"
							{
								gint j = 0;
#line 157 "../src/Utils/Blurhash.vala"
								j = 0;
#line 852 "Blurhash.c"
								{
									gboolean _tmp29_ = FALSE;
#line 157 "../src/Utils/Blurhash.vala"
									_tmp29_ = TRUE;
#line 157 "../src/Utils/Blurhash.vala"
									while (TRUE) {
#line 859 "Blurhash.c"
										gfloat basis_y = 0.0F;
#line 157 "../src/Utils/Blurhash.vala"
										if (!_tmp29_) {
#line 863 "Blurhash.c"
											gint _tmp30_;
#line 157 "../src/Utils/Blurhash.vala"
											_tmp30_ = j;
#line 157 "../src/Utils/Blurhash.vala"
											j = _tmp30_ + 1;
#line 869 "Blurhash.c"
										}
#line 157 "../src/Utils/Blurhash.vala"
										_tmp29_ = FALSE;
#line 157 "../src/Utils/Blurhash.vala"
										if (!(j < num_y)) {
#line 157 "../src/Utils/Blurhash.vala"
											break;
#line 877 "Blurhash.c"
										}
#line 158 "../src/Utils/Blurhash.vala"
										basis_y = cosf (yh * j);
#line 881 "Blurhash.c"
										{
											gint i = 0;
#line 159 "../src/Utils/Blurhash.vala"
											i = 0;
#line 886 "Blurhash.c"
											{
												gboolean _tmp31_ = FALSE;
#line 159 "../src/Utils/Blurhash.vala"
												_tmp31_ = TRUE;
#line 159 "../src/Utils/Blurhash.vala"
												while (TRUE) {
#line 893 "Blurhash.c"
													gfloat basis = 0.0F;
													gint color_index = 0;
													gfloat* _tmp33_;
													gint _tmp33__length1;
													gfloat _tmp34_;
													gfloat* _tmp35_;
													gint _tmp35__length1;
													gfloat _tmp36_;
													gfloat* _tmp37_;
													gint _tmp37__length1;
													gfloat _tmp38_;
#line 159 "../src/Utils/Blurhash.vala"
													if (!_tmp31_) {
#line 907 "Blurhash.c"
														gint _tmp32_;
#line 159 "../src/Utils/Blurhash.vala"
														_tmp32_ = i;
#line 159 "../src/Utils/Blurhash.vala"
														i = _tmp32_ + 1;
#line 913 "Blurhash.c"
													}
#line 159 "../src/Utils/Blurhash.vala"
													_tmp31_ = FALSE;
#line 159 "../src/Utils/Blurhash.vala"
													if (!(i < num_x)) {
#line 159 "../src/Utils/Blurhash.vala"
														break;
#line 921 "Blurhash.c"
													}
#line 160 "../src/Utils/Blurhash.vala"
													basis = cosf (xw * i) * basis_y;
#line 162 "../src/Utils/Blurhash.vala"
													color_index = (i + (j * num_x)) * 3;
#line 163 "../src/Utils/Blurhash.vala"
													_tmp33_ = colors;
#line 163 "../src/Utils/Blurhash.vala"
													_tmp33__length1 = colors_length1;
#line 163 "../src/Utils/Blurhash.vala"
													_tmp34_ = _tmp33_[color_index];
#line 163 "../src/Utils/Blurhash.vala"
													r += _tmp34_ * basis;
#line 164 "../src/Utils/Blurhash.vala"
													_tmp35_ = colors;
#line 164 "../src/Utils/Blurhash.vala"
													_tmp35__length1 = colors_length1;
#line 164 "../src/Utils/Blurhash.vala"
													_tmp36_ = _tmp35_[color_index + 1];
#line 164 "../src/Utils/Blurhash.vala"
													g += _tmp36_ * basis;
#line 165 "../src/Utils/Blurhash.vala"
													_tmp37_ = colors;
#line 165 "../src/Utils/Blurhash.vala"
													_tmp37__length1 = colors_length1;
#line 165 "../src/Utils/Blurhash.vala"
													_tmp38_ = _tmp37_[color_index + 2];
#line 165 "../src/Utils/Blurhash.vala"
													b += _tmp38_ * basis;
#line 951 "Blurhash.c"
												}
											}
										}
									}
								}
							}
#line 169 "../src/Utils/Blurhash.vala"
							pixel_index = (4 * x) + (y * bytes_per_row);
#line 170 "../src/Utils/Blurhash.vala"
							_tmp39_ = res;
#line 170 "../src/Utils/Blurhash.vala"
							_tmp39__length1 = res_length1;
#line 170 "../src/Utils/Blurhash.vala"
							_tmp39_[pixel_index] = (guint8) tuba_blurhash_linear_to_srgb (r);
#line 171 "../src/Utils/Blurhash.vala"
							_tmp40_ = res;
#line 171 "../src/Utils/Blurhash.vala"
							_tmp40__length1 = res_length1;
#line 171 "../src/Utils/Blurhash.vala"
							_tmp40_[pixel_index + 1] = (guint8) tuba_blurhash_linear_to_srgb (g);
#line 172 "../src/Utils/Blurhash.vala"
							_tmp41_ = res;
#line 172 "../src/Utils/Blurhash.vala"
							_tmp41__length1 = res_length1;
#line 172 "../src/Utils/Blurhash.vala"
							_tmp41_[pixel_index + 2] = (guint8) tuba_blurhash_linear_to_srgb (b);
#line 174 "../src/Utils/Blurhash.vala"
							if (has_alpha) {
#line 980 "Blurhash.c"
								guint8* _tmp42_;
								gint _tmp42__length1;
#line 175 "../src/Utils/Blurhash.vala"
								_tmp42_ = res;
#line 175 "../src/Utils/Blurhash.vala"
								_tmp42__length1 = res_length1;
#line 175 "../src/Utils/Blurhash.vala"
								_tmp42_[pixel_index + 3] = (guint8) 255;
#line 989 "Blurhash.c"
							}
						}
					}
				}
			}
		}
	}
#line 179 "../src/Utils/Blurhash.vala"
	_tmp43_ = res;
#line 179 "../src/Utils/Blurhash.vala"
	_tmp43__length1 = res_length1;
#line 179 "../src/Utils/Blurhash.vala"
	if (result_length1) {
#line 179 "../src/Utils/Blurhash.vala"
		*result_length1 = _tmp43__length1;
#line 1005 "Blurhash.c"
	}
#line 179 "../src/Utils/Blurhash.vala"
	result = _tmp43_;
#line 179 "../src/Utils/Blurhash.vala"
	colors = (g_free (colors), NULL);
#line 179 "../src/Utils/Blurhash.vala"
	return result;
#line 1013 "Blurhash.c"
}

static guint8*
_vala_array_dup16 (guint8* self,
                   gssize length)
{
#line 186 "../src/Utils/Blurhash.vala"
	if (length > 0) {
#line 186 "../src/Utils/Blurhash.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 1024 "Blurhash.c"
	}
#line 186 "../src/Utils/Blurhash.vala"
	return NULL;
#line 1028 "Blurhash.c"
}

static void
_g_free_gdk_pixbuf_destroy_notify (guint8* pixels,
                                   gpointer self)
{
#line 186 "../src/Utils/Blurhash.vala"
	g_free (pixels);
#line 1037 "Blurhash.c"
}

GdkPixbuf*
tuba_blurhash_blurhash_to_pixbuf (const gchar* blurhash,
                                  gint width,
                                  gint height)
{
	guint8* data = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_;
	gint data_length1;
	gint _data_size_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* result;
#line 182 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (blurhash != NULL, NULL);
#line 183 "../src/Utils/Blurhash.vala"
	_tmp1_ = tuba_blurhash_decode_to_data (blurhash, width, height, 1, TRUE, &_tmp0_);
#line 183 "../src/Utils/Blurhash.vala"
	data = _tmp1_;
#line 183 "../src/Utils/Blurhash.vala"
	data_length1 = _tmp0_;
#line 183 "../src/Utils/Blurhash.vala"
	_data_size_ = data_length1;
#line 184 "../src/Utils/Blurhash.vala"
	_tmp2_ = data;
#line 184 "../src/Utils/Blurhash.vala"
	_tmp2__length1 = data_length1;
#line 184 "../src/Utils/Blurhash.vala"
	if (_tmp2_ == NULL) {
#line 184 "../src/Utils/Blurhash.vala"
		result = NULL;
#line 184 "../src/Utils/Blurhash.vala"
		data = (g_free (data), NULL);
#line 184 "../src/Utils/Blurhash.vala"
		return result;
#line 1080 "Blurhash.c"
	}
#line 186 "../src/Utils/Blurhash.vala"
	_tmp3_ = data;
#line 186 "../src/Utils/Blurhash.vala"
	_tmp3__length1 = data_length1;
#line 186 "../src/Utils/Blurhash.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup16 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 186 "../src/Utils/Blurhash.vala"
	_tmp4__length1 = _tmp3__length1;
#line 186 "../src/Utils/Blurhash.vala"
	_tmp5_ = gdk_pixbuf_new_from_data (_tmp4_, GDK_COLORSPACE_RGB, TRUE, 8, width, height, 4 * height, _g_free_gdk_pixbuf_destroy_notify, NULL);
#line 186 "../src/Utils/Blurhash.vala"
	result = _tmp5_;
#line 186 "../src/Utils/Blurhash.vala"
	data = (g_free (data), NULL);
#line 186 "../src/Utils/Blurhash.vala"
	return result;
#line 1098 "Blurhash.c"
}

TubaBlurhash*
tuba_blurhash_construct (GType object_type)
{
	TubaBlurhash* self = NULL;
#line 3 "../src/Utils/Blurhash.vala"
	self = (TubaBlurhash*) g_type_create_instance (object_type);
#line 3 "../src/Utils/Blurhash.vala"
	return self;
#line 1109 "Blurhash.c"
}

TubaBlurhash*
tuba_blurhash_new (void)
{
#line 3 "../src/Utils/Blurhash.vala"
	return tuba_blurhash_construct (TUBA_TYPE_BLURHASH);
#line 1117 "Blurhash.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1134 "Blurhash.c"
}

gint
tuba_blurhash_base83_decode (const gchar* value)
{
	gint res = 0;
	gint result;
#line 33 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 34 "../src/Utils/Blurhash.vala"
	res = 0;
#line 1146 "Blurhash.c"
	{
		gint i = 0;
#line 36 "../src/Utils/Blurhash.vala"
		i = 0;
#line 1151 "Blurhash.c"
		{
			gboolean _tmp0_ = FALSE;
#line 36 "../src/Utils/Blurhash.vala"
			_tmp0_ = TRUE;
#line 36 "../src/Utils/Blurhash.vala"
			while (TRUE) {
#line 1158 "Blurhash.c"
				gint _tmp2_;
				gint _tmp3_;
				gchar character = '\0';
				gint index = 0;
#line 36 "../src/Utils/Blurhash.vala"
				if (!_tmp0_) {
#line 1165 "Blurhash.c"
					gint _tmp1_;
#line 36 "../src/Utils/Blurhash.vala"
					_tmp1_ = i;
#line 36 "../src/Utils/Blurhash.vala"
					i = _tmp1_ + 1;
#line 1171 "Blurhash.c"
				}
#line 36 "../src/Utils/Blurhash.vala"
				_tmp0_ = FALSE;
#line 36 "../src/Utils/Blurhash.vala"
				_tmp2_ = strlen (value);
#line 36 "../src/Utils/Blurhash.vala"
				_tmp3_ = _tmp2_;
#line 36 "../src/Utils/Blurhash.vala"
				if (!(i < _tmp3_)) {
#line 36 "../src/Utils/Blurhash.vala"
					break;
#line 1183 "Blurhash.c"
				}
#line 37 "../src/Utils/Blurhash.vala"
				character = string_get (value, (glong) i);
#line 39 "../src/Utils/Blurhash.vala"
				index = -1;
#line 1189 "Blurhash.c"
				{
					gint j = 0;
#line 40 "../src/Utils/Blurhash.vala"
					j = 0;
#line 1194 "Blurhash.c"
					{
						gboolean _tmp4_ = FALSE;
#line 40 "../src/Utils/Blurhash.vala"
						_tmp4_ = TRUE;
#line 40 "../src/Utils/Blurhash.vala"
						while (TRUE) {
#line 1201 "Blurhash.c"
							gchar _tmp6_;
#line 40 "../src/Utils/Blurhash.vala"
							if (!_tmp4_) {
#line 1205 "Blurhash.c"
								gint _tmp5_;
#line 40 "../src/Utils/Blurhash.vala"
								_tmp5_ = j;
#line 40 "../src/Utils/Blurhash.vala"
								j = _tmp5_ + 1;
#line 1211 "Blurhash.c"
							}
#line 40 "../src/Utils/Blurhash.vala"
							_tmp4_ = FALSE;
#line 40 "../src/Utils/Blurhash.vala"
							if (!(j < 83)) {
#line 40 "../src/Utils/Blurhash.vala"
								break;
#line 1219 "Blurhash.c"
							}
#line 41 "../src/Utils/Blurhash.vala"
							_tmp6_ = TUBA_BLURHASH_BASE83_CHARACTERS[j];
#line 41 "../src/Utils/Blurhash.vala"
							if (_tmp6_ == character) {
#line 42 "../src/Utils/Blurhash.vala"
								index = j;
#line 43 "../src/Utils/Blurhash.vala"
								break;
#line 1229 "Blurhash.c"
							}
						}
					}
				}
#line 46 "../src/Utils/Blurhash.vala"
				if (index == -1) {
#line 46 "../src/Utils/Blurhash.vala"
					result = 0;
#line 46 "../src/Utils/Blurhash.vala"
					return result;
#line 1240 "Blurhash.c"
				}
#line 48 "../src/Utils/Blurhash.vala"
				res = (res * 83) + index;
#line 1244 "Blurhash.c"
			}
		}
	}
#line 51 "../src/Utils/Blurhash.vala"
	result = res;
#line 51 "../src/Utils/Blurhash.vala"
	return result;
#line 1252 "Blurhash.c"
}

TubaBlurhashBase83*
tuba_blurhash_base83_construct (GType object_type)
{
	TubaBlurhashBase83* self = NULL;
#line 16 "../src/Utils/Blurhash.vala"
	self = (TubaBlurhashBase83*) g_type_create_instance (object_type);
#line 16 "../src/Utils/Blurhash.vala"
	return self;
#line 1263 "Blurhash.c"
}

TubaBlurhashBase83*
tuba_blurhash_base83_new (void)
{
#line 16 "../src/Utils/Blurhash.vala"
	return tuba_blurhash_base83_construct (TUBA_BLURHASH_TYPE_BASE83);
#line 1271 "Blurhash.c"
}

static void
tuba_blurhash_value_base83_init (GValue* value)
{
#line 16 "../src/Utils/Blurhash.vala"
	value->data[0].v_pointer = NULL;
#line 1279 "Blurhash.c"
}

static void
tuba_blurhash_value_base83_free_value (GValue* value)
{
#line 16 "../src/Utils/Blurhash.vala"
	if (value->data[0].v_pointer) {
#line 16 "../src/Utils/Blurhash.vala"
		tuba_blurhash_base83_unref (value->data[0].v_pointer);
#line 1289 "Blurhash.c"
	}
}

static void
tuba_blurhash_value_base83_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 16 "../src/Utils/Blurhash.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "../src/Utils/Blurhash.vala"
		dest_value->data[0].v_pointer = tuba_blurhash_base83_ref (src_value->data[0].v_pointer);
#line 1301 "Blurhash.c"
	} else {
#line 16 "../src/Utils/Blurhash.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1305 "Blurhash.c"
	}
}

static gpointer
tuba_blurhash_value_base83_peek_pointer (const GValue* value)
{
#line 16 "../src/Utils/Blurhash.vala"
	return value->data[0].v_pointer;
#line 1314 "Blurhash.c"
}

static gchar*
tuba_blurhash_value_base83_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 16 "../src/Utils/Blurhash.vala"
	if (collect_values[0].v_pointer) {
#line 1325 "Blurhash.c"
		TubaBlurhashBase83 * object;
		object = collect_values[0].v_pointer;
#line 16 "../src/Utils/Blurhash.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "../src/Utils/Blurhash.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1332 "Blurhash.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "../src/Utils/Blurhash.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1336 "Blurhash.c"
		}
#line 16 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = tuba_blurhash_base83_ref (object);
#line 1340 "Blurhash.c"
	} else {
#line 16 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = NULL;
#line 1344 "Blurhash.c"
	}
#line 16 "../src/Utils/Blurhash.vala"
	return NULL;
#line 1348 "Blurhash.c"
}

static gchar*
tuba_blurhash_value_base83_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	TubaBlurhashBase83 ** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "../src/Utils/Blurhash.vala"
	if (!object_p) {
#line 16 "../src/Utils/Blurhash.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1363 "Blurhash.c"
	}
#line 16 "../src/Utils/Blurhash.vala"
	if (!value->data[0].v_pointer) {
#line 16 "../src/Utils/Blurhash.vala"
		*object_p = NULL;
#line 1369 "Blurhash.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "../src/Utils/Blurhash.vala"
		*object_p = value->data[0].v_pointer;
#line 1373 "Blurhash.c"
	} else {
#line 16 "../src/Utils/Blurhash.vala"
		*object_p = tuba_blurhash_base83_ref (value->data[0].v_pointer);
#line 1377 "Blurhash.c"
	}
#line 16 "../src/Utils/Blurhash.vala"
	return NULL;
#line 1381 "Blurhash.c"
}

GParamSpec*
tuba_blurhash_param_spec_base83 (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	TubaBlurhashParamSpecBase83* spec;
#line 16 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TUBA_BLURHASH_TYPE_BASE83), NULL);
#line 16 "../src/Utils/Blurhash.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "../src/Utils/Blurhash.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "../src/Utils/Blurhash.vala"
	return G_PARAM_SPEC (spec);
#line 1400 "Blurhash.c"
}

gpointer
tuba_blurhash_value_get_base83 (const GValue* value)
{
#line 16 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUBA_BLURHASH_TYPE_BASE83), NULL);
#line 16 "../src/Utils/Blurhash.vala"
	return value->data[0].v_pointer;
#line 1410 "Blurhash.c"
}

void
tuba_blurhash_value_set_base83 (GValue* value,
                                gpointer v_object)
{
	TubaBlurhashBase83 * old;
#line 16 "../src/Utils/Blurhash.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUBA_BLURHASH_TYPE_BASE83));
#line 16 "../src/Utils/Blurhash.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/Utils/Blurhash.vala"
	if (v_object) {
#line 16 "../src/Utils/Blurhash.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TUBA_BLURHASH_TYPE_BASE83));
#line 16 "../src/Utils/Blurhash.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = v_object;
#line 16 "../src/Utils/Blurhash.vala"
		tuba_blurhash_base83_ref (value->data[0].v_pointer);
#line 1432 "Blurhash.c"
	} else {
#line 16 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = NULL;
#line 1436 "Blurhash.c"
	}
#line 16 "../src/Utils/Blurhash.vala"
	if (old) {
#line 16 "../src/Utils/Blurhash.vala"
		tuba_blurhash_base83_unref (old);
#line 1442 "Blurhash.c"
	}
}

void
tuba_blurhash_value_take_base83 (GValue* value,
                                 gpointer v_object)
{
	TubaBlurhashBase83 * old;
#line 16 "../src/Utils/Blurhash.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUBA_BLURHASH_TYPE_BASE83));
#line 16 "../src/Utils/Blurhash.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/Utils/Blurhash.vala"
	if (v_object) {
#line 16 "../src/Utils/Blurhash.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TUBA_BLURHASH_TYPE_BASE83));
#line 16 "../src/Utils/Blurhash.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = v_object;
#line 1463 "Blurhash.c"
	} else {
#line 16 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = NULL;
#line 1467 "Blurhash.c"
	}
#line 16 "../src/Utils/Blurhash.vala"
	if (old) {
#line 16 "../src/Utils/Blurhash.vala"
		tuba_blurhash_base83_unref (old);
#line 1473 "Blurhash.c"
	}
}

static void
tuba_blurhash_base83_class_init (TubaBlurhashBase83Class * klass,
                                 gpointer klass_data)
{
#line 16 "../src/Utils/Blurhash.vala"
	tuba_blurhash_base83_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/Utils/Blurhash.vala"
	((TubaBlurhashBase83Class *) klass)->finalize = tuba_blurhash_base83_finalize;
#line 1485 "Blurhash.c"
}

static void
tuba_blurhash_base83_instance_init (TubaBlurhashBase83 * self,
                                    gpointer klass)
{
#line 16 "../src/Utils/Blurhash.vala"
	self->ref_count = 1;
#line 1494 "Blurhash.c"
}

static void
tuba_blurhash_base83_finalize (TubaBlurhashBase83 * obj)
{
	TubaBlurhashBase83 * self;
#line 16 "../src/Utils/Blurhash.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_BLURHASH_TYPE_BASE83, TubaBlurhashBase83);
#line 16 "../src/Utils/Blurhash.vala"
	g_signal_handlers_destroy (self);
#line 1505 "Blurhash.c"
}

 G_GNUC_NO_INLINE static GType
tuba_blurhash_base83_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { tuba_blurhash_value_base83_init, tuba_blurhash_value_base83_free_value, tuba_blurhash_value_base83_copy_value, tuba_blurhash_value_base83_peek_pointer, "p", tuba_blurhash_value_base83_collect_value, "p", tuba_blurhash_value_base83_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TubaBlurhashBase83Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_blurhash_base83_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaBlurhashBase83), 0, (GInstanceInitFunc) tuba_blurhash_base83_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType tuba_blurhash_base83_type_id;
	tuba_blurhash_base83_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TubaBlurhashBase83", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return tuba_blurhash_base83_type_id;
}

GType
tuba_blurhash_base83_get_type (void)
{
	static gsize tuba_blurhash_base83_type_id__once = 0;
	if (g_once_init_enter (&tuba_blurhash_base83_type_id__once)) {
		GType tuba_blurhash_base83_type_id;
		tuba_blurhash_base83_type_id = tuba_blurhash_base83_get_type_once ();
		g_once_init_leave (&tuba_blurhash_base83_type_id__once, tuba_blurhash_base83_type_id);
	}
	return tuba_blurhash_base83_type_id__once;
}

gpointer
tuba_blurhash_base83_ref (gpointer instance)
{
	TubaBlurhashBase83 * self;
	self = instance;
#line 16 "../src/Utils/Blurhash.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "../src/Utils/Blurhash.vala"
	return instance;
#line 1540 "Blurhash.c"
}

void
tuba_blurhash_base83_unref (gpointer instance)
{
	TubaBlurhashBase83 * self;
	self = instance;
#line 16 "../src/Utils/Blurhash.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "../src/Utils/Blurhash.vala"
		TUBA_BLURHASH_BASE83_GET_CLASS (self)->finalize (self);
#line 16 "../src/Utils/Blurhash.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1554 "Blurhash.c"
	}
}

static TubaBlurhashAverageColor*
tuba_blurhash_average_color_dup (const TubaBlurhashAverageColor* self)
{
	TubaBlurhashAverageColor* dup;
#line 4 "../src/Utils/Blurhash.vala"
	dup = g_new0 (TubaBlurhashAverageColor, 1);
#line 4 "../src/Utils/Blurhash.vala"
	memcpy (dup, self, sizeof (TubaBlurhashAverageColor));
#line 4 "../src/Utils/Blurhash.vala"
	return dup;
#line 1568 "Blurhash.c"
}

static void
tuba_blurhash_average_color_free (TubaBlurhashAverageColor* self)
{
#line 4 "../src/Utils/Blurhash.vala"
	g_free (self);
#line 1576 "Blurhash.c"
}

 G_GNUC_NO_INLINE static GType
tuba_blurhash_average_color_get_type_once (void)
{
	GType tuba_blurhash_average_color_type_id;
	tuba_blurhash_average_color_type_id = g_boxed_type_register_static ("TubaBlurhashAverageColor", (GBoxedCopyFunc) tuba_blurhash_average_color_dup, (GBoxedFreeFunc) tuba_blurhash_average_color_free);
	return tuba_blurhash_average_color_type_id;
}

static GType
tuba_blurhash_average_color_get_type (void)
{
	static gsize tuba_blurhash_average_color_type_id__once = 0;
	if (g_once_init_enter (&tuba_blurhash_average_color_type_id__once)) {
		GType tuba_blurhash_average_color_type_id;
		tuba_blurhash_average_color_type_id = tuba_blurhash_average_color_get_type_once ();
		g_once_init_leave (&tuba_blurhash_average_color_type_id__once, tuba_blurhash_average_color_type_id);
	}
	return tuba_blurhash_average_color_type_id__once;
}

static TubaBlurhashColorSRGB*
tuba_blurhash_color_srgb_dup (const TubaBlurhashColorSRGB* self)
{
	TubaBlurhashColorSRGB* dup;
#line 10 "../src/Utils/Blurhash.vala"
	dup = g_new0 (TubaBlurhashColorSRGB, 1);
#line 10 "../src/Utils/Blurhash.vala"
	memcpy (dup, self, sizeof (TubaBlurhashColorSRGB));
#line 10 "../src/Utils/Blurhash.vala"
	return dup;
#line 1609 "Blurhash.c"
}

static void
tuba_blurhash_color_srgb_free (TubaBlurhashColorSRGB* self)
{
#line 10 "../src/Utils/Blurhash.vala"
	g_free (self);
#line 1617 "Blurhash.c"
}

 G_GNUC_NO_INLINE static GType
tuba_blurhash_color_srgb_get_type_once (void)
{
	GType tuba_blurhash_color_srgb_type_id;
	tuba_blurhash_color_srgb_type_id = g_boxed_type_register_static ("TubaBlurhashColorSRGB", (GBoxedCopyFunc) tuba_blurhash_color_srgb_dup, (GBoxedFreeFunc) tuba_blurhash_color_srgb_free);
	return tuba_blurhash_color_srgb_type_id;
}

static GType
tuba_blurhash_color_srgb_get_type (void)
{
	static gsize tuba_blurhash_color_srgb_type_id__once = 0;
	if (g_once_init_enter (&tuba_blurhash_color_srgb_type_id__once)) {
		GType tuba_blurhash_color_srgb_type_id;
		tuba_blurhash_color_srgb_type_id = tuba_blurhash_color_srgb_get_type_once ();
		g_once_init_leave (&tuba_blurhash_color_srgb_type_id__once, tuba_blurhash_color_srgb_type_id);
	}
	return tuba_blurhash_color_srgb_type_id__once;
}

static void
tuba_value_blurhash_init (GValue* value)
{
#line 3 "../src/Utils/Blurhash.vala"
	value->data[0].v_pointer = NULL;
#line 1645 "Blurhash.c"
}

static void
tuba_value_blurhash_free_value (GValue* value)
{
#line 3 "../src/Utils/Blurhash.vala"
	if (value->data[0].v_pointer) {
#line 3 "../src/Utils/Blurhash.vala"
		tuba_blurhash_unref (value->data[0].v_pointer);
#line 1655 "Blurhash.c"
	}
}

static void
tuba_value_blurhash_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 3 "../src/Utils/Blurhash.vala"
	if (src_value->data[0].v_pointer) {
#line 3 "../src/Utils/Blurhash.vala"
		dest_value->data[0].v_pointer = tuba_blurhash_ref (src_value->data[0].v_pointer);
#line 1667 "Blurhash.c"
	} else {
#line 3 "../src/Utils/Blurhash.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1671 "Blurhash.c"
	}
}

static gpointer
tuba_value_blurhash_peek_pointer (const GValue* value)
{
#line 3 "../src/Utils/Blurhash.vala"
	return value->data[0].v_pointer;
#line 1680 "Blurhash.c"
}

static gchar*
tuba_value_blurhash_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 3 "../src/Utils/Blurhash.vala"
	if (collect_values[0].v_pointer) {
#line 1691 "Blurhash.c"
		TubaBlurhash * object;
		object = collect_values[0].v_pointer;
#line 3 "../src/Utils/Blurhash.vala"
		if (object->parent_instance.g_class == NULL) {
#line 3 "../src/Utils/Blurhash.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1698 "Blurhash.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 3 "../src/Utils/Blurhash.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1702 "Blurhash.c"
		}
#line 3 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = tuba_blurhash_ref (object);
#line 1706 "Blurhash.c"
	} else {
#line 3 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = NULL;
#line 1710 "Blurhash.c"
	}
#line 3 "../src/Utils/Blurhash.vala"
	return NULL;
#line 1714 "Blurhash.c"
}

static gchar*
tuba_value_blurhash_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	TubaBlurhash ** object_p;
	object_p = collect_values[0].v_pointer;
#line 3 "../src/Utils/Blurhash.vala"
	if (!object_p) {
#line 3 "../src/Utils/Blurhash.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1729 "Blurhash.c"
	}
#line 3 "../src/Utils/Blurhash.vala"
	if (!value->data[0].v_pointer) {
#line 3 "../src/Utils/Blurhash.vala"
		*object_p = NULL;
#line 1735 "Blurhash.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 3 "../src/Utils/Blurhash.vala"
		*object_p = value->data[0].v_pointer;
#line 1739 "Blurhash.c"
	} else {
#line 3 "../src/Utils/Blurhash.vala"
		*object_p = tuba_blurhash_ref (value->data[0].v_pointer);
#line 1743 "Blurhash.c"
	}
#line 3 "../src/Utils/Blurhash.vala"
	return NULL;
#line 1747 "Blurhash.c"
}

GParamSpec*
tuba_param_spec_blurhash (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	TubaParamSpecBlurhash* spec;
#line 3 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TUBA_TYPE_BLURHASH), NULL);
#line 3 "../src/Utils/Blurhash.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 3 "../src/Utils/Blurhash.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 3 "../src/Utils/Blurhash.vala"
	return G_PARAM_SPEC (spec);
#line 1766 "Blurhash.c"
}

gpointer
tuba_value_get_blurhash (const GValue* value)
{
#line 3 "../src/Utils/Blurhash.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUBA_TYPE_BLURHASH), NULL);
#line 3 "../src/Utils/Blurhash.vala"
	return value->data[0].v_pointer;
#line 1776 "Blurhash.c"
}

void
tuba_value_set_blurhash (GValue* value,
                         gpointer v_object)
{
	TubaBlurhash * old;
#line 3 "../src/Utils/Blurhash.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUBA_TYPE_BLURHASH));
#line 3 "../src/Utils/Blurhash.vala"
	old = value->data[0].v_pointer;
#line 3 "../src/Utils/Blurhash.vala"
	if (v_object) {
#line 3 "../src/Utils/Blurhash.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TUBA_TYPE_BLURHASH));
#line 3 "../src/Utils/Blurhash.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 3 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = v_object;
#line 3 "../src/Utils/Blurhash.vala"
		tuba_blurhash_ref (value->data[0].v_pointer);
#line 1798 "Blurhash.c"
	} else {
#line 3 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = NULL;
#line 1802 "Blurhash.c"
	}
#line 3 "../src/Utils/Blurhash.vala"
	if (old) {
#line 3 "../src/Utils/Blurhash.vala"
		tuba_blurhash_unref (old);
#line 1808 "Blurhash.c"
	}
}

void
tuba_value_take_blurhash (GValue* value,
                          gpointer v_object)
{
	TubaBlurhash * old;
#line 3 "../src/Utils/Blurhash.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUBA_TYPE_BLURHASH));
#line 3 "../src/Utils/Blurhash.vala"
	old = value->data[0].v_pointer;
#line 3 "../src/Utils/Blurhash.vala"
	if (v_object) {
#line 3 "../src/Utils/Blurhash.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TUBA_TYPE_BLURHASH));
#line 3 "../src/Utils/Blurhash.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 3 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = v_object;
#line 1829 "Blurhash.c"
	} else {
#line 3 "../src/Utils/Blurhash.vala"
		value->data[0].v_pointer = NULL;
#line 1833 "Blurhash.c"
	}
#line 3 "../src/Utils/Blurhash.vala"
	if (old) {
#line 3 "../src/Utils/Blurhash.vala"
		tuba_blurhash_unref (old);
#line 1839 "Blurhash.c"
	}
}

static void
tuba_blurhash_class_init (TubaBlurhashClass * klass,
                          gpointer klass_data)
{
#line 3 "../src/Utils/Blurhash.vala"
	tuba_blurhash_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/Utils/Blurhash.vala"
	((TubaBlurhashClass *) klass)->finalize = tuba_blurhash_finalize;
#line 1851 "Blurhash.c"
}

static void
tuba_blurhash_instance_init (TubaBlurhash * self,
                             gpointer klass)
{
#line 3 "../src/Utils/Blurhash.vala"
	self->ref_count = 1;
#line 1860 "Blurhash.c"
}

static void
tuba_blurhash_finalize (TubaBlurhash * obj)
{
	TubaBlurhash * self;
#line 3 "../src/Utils/Blurhash.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_TYPE_BLURHASH, TubaBlurhash);
#line 3 "../src/Utils/Blurhash.vala"
	g_signal_handlers_destroy (self);
#line 1871 "Blurhash.c"
}

 G_GNUC_NO_INLINE static GType
tuba_blurhash_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { tuba_value_blurhash_init, tuba_value_blurhash_free_value, tuba_value_blurhash_copy_value, tuba_value_blurhash_peek_pointer, "p", tuba_value_blurhash_collect_value, "p", tuba_value_blurhash_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TubaBlurhashClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_blurhash_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaBlurhash), 0, (GInstanceInitFunc) tuba_blurhash_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType tuba_blurhash_type_id;
	tuba_blurhash_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TubaBlurhash", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return tuba_blurhash_type_id;
}

GType
tuba_blurhash_get_type (void)
{
	static gsize tuba_blurhash_type_id__once = 0;
	if (g_once_init_enter (&tuba_blurhash_type_id__once)) {
		GType tuba_blurhash_type_id;
		tuba_blurhash_type_id = tuba_blurhash_get_type_once ();
		g_once_init_leave (&tuba_blurhash_type_id__once, tuba_blurhash_type_id);
	}
	return tuba_blurhash_type_id__once;
}

gpointer
tuba_blurhash_ref (gpointer instance)
{
	TubaBlurhash * self;
	self = instance;
#line 3 "../src/Utils/Blurhash.vala"
	g_atomic_int_inc (&self->ref_count);
#line 3 "../src/Utils/Blurhash.vala"
	return instance;
#line 1906 "Blurhash.c"
}

void
tuba_blurhash_unref (gpointer instance)
{
	TubaBlurhash * self;
	self = instance;
#line 3 "../src/Utils/Blurhash.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 3 "../src/Utils/Blurhash.vala"
		TUBA_BLURHASH_GET_CLASS (self)->finalize (self);
#line 3 "../src/Utils/Blurhash.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1920 "Blurhash.c"
	}
}

